<?php

/*  Alternate WebshopEngine
(C) 2009-2016 by Alternate Tools
-----------------------------------------------------

File:         class_custfield.php
Description:  Class cCustField definition,
              handling of the custom fields in article/basket class

*/

if (!defined("CLASS_CUSTFIELD"))
{
    define ("CLASS_CUSTFIELD", "DEFINED");

    class cCustField
    {
        var $m_artCustFieldsNames = array();
        var $m_artCustFieldsValues = array();
        var $m_artCustFieldCount;

        function __construct()
        {
            $this->m_artCustFieldCount = 5;  // default
            $this->InitCustFields();
        }

        function cCustField() // PHP 4
        {
            $this->m_artCustFieldCount = 5;  // default
            $this->InitCustFields();
        }

        function InitCustFields()
        {
            unset($m_artCustFieldsNames);
            unset($m_artCustFieldsValues);

            $this->m_artCustFieldsNames = array();
            $this->m_artCustFieldsValues = array();

            for ($i = 0; $i < $this->m_artCustFieldCount; $i ++)
            {
                $this->m_artCustFieldsNames[] = "";
                $this->m_artCustFieldsValues[] = "";
            }
        }

        // Getter and setter
        function SetCustFieldCount($count)
        {
            $this->m_artCustFieldCount = $count;
            $this->InitCustFields();
        }
        function GetCustFieldCount()
        {
            return $this->m_artCustFieldCount;
        }
        
        function GetCustFieldName($index)
        {
            if ($index <= $this->m_artCustFieldCount)
            {
                return $this->m_artCustFieldsNames[$index - 1];
            }
            return "";
        }

        function GetCustFieldValue($index)
        {
            if ($index <= $this->m_artCustFieldCount)
            {
                return $this->m_artCustFieldsValues[$index - 1];
            }
            return "";
        }

        function SetCustFieldName($index, $value)
        {
            if ($index <= $this->m_artCustFieldCount)
            {
                $this->m_artCustFieldsNames[$index - 1] = $value;
            }
        }

        function SetCustFieldValue($index, $value)
        {
            if ($index <= $this->m_artCustFieldCount)
            {
                $this->m_artCustFieldsValues[$index - 1] = $value;
            }
        }
    }
}