<?php

/*  Alternate WebshopEngine
(C) 2009-2014 by Alternate Tools
-----------------------------------------------------

File:         class_orderlist.php
Description:  Class cOrderList definition,
              handling of the order lists

*/

include "class_order.php";

if (!defined("CLASS_ORDERLIST"))
{
    define ("CLASS_ORDERLIST", "DEFINED");

    class cOrderList
    {

        var $m_ordlFolder;
        var $m_ordlIds = array();

        function __construct()
        {
            $this->Init();
        }

        function cOrderList()  // PHP 4
        {
            $this->__construct();
        }

        function Init()
        {
            unset($m_ordlIds);
            $this->m_ordlFolder = "";
        }

        function SetFolder($ordlFolder)
        {
            $this->m_ordlFolder = $ordlFolder;
        }

        function SetOrderList($ordlArray)
        {
            $this->m_ordlIds = $ordlArray;
        }

        function GetOrderList()
        {
            return $this->m_ordlIds;
        }
        
        function LoadOrderList($filter = 0)
        {
            if (is_dir($this->m_ordlFolder) == false)
                return false;
                
            $rDir = dir($this->m_ordlFolder);
            $strEntry = "";
            $fileName = "";
            $ordOrder = new cOrder;
            $ordOrder->SetFolder($this->m_ordlFolder);

            while (false !== ($strEntry = $rDir->read()))
            {
                if (substr($strEntry, -4 ) == '.ord')
                {
                    $fileName = substr($strEntry, 0, strlen($strEntry) - 4);
                    if ($filter == 0) // all
                        $this->m_ordlIds[] = $fileName;
                    else
                    {
                        if ($ordOrder->LoadOrderFromId($fileName) == true)
                        {
                            $addMe = false;
                            switch($filter)
                            {
                                case 1:   // done
                                   if ($ordOrder->IsDone() == true)
                                       $addMe = true;
                                break;
                                case 2:   // undone
                                   if ($ordOrder->IsDone() == false)
                                       $addMe = true;
                                break;
                                case 3:  // this year
                                   if (substr($ordOrder->GetDate(), 0, 4) == date("Y"))
                                       $addMe = true;
                                break;
                                case 4:  // this month
                                   if (substr($ordOrder->GetDate(), 0, 7) == date("Y-m"))
                                       $addMe = true;
                                break;
                            }
                            if ($addMe == true)
                                $this->m_ordlIds[] = $fileName;
                        }
                    }
                }
            }
            rsort($this->m_ordlIds);
            return true;
        }

        function GetTotalOrders()
        {
            $this->LoadOrderList();
            if (isset($this->m_ordlIds) == false)
                return 0;
            return count ($this->m_ordlIds);
        }

    }
}
?>