<?php

/*  Alternate WebshopEngine
(C) 2009-2014 by Alternate Tools
-----------------------------------------------------

File:         mod_shop.php
Description:  Functions for the shop area

*/
    include "class_textfile.php";
    include "class_count.php";
    include "class_article.php";
    include "class_articlesidebar.php";
    include "class_systemfile.php";
    include "class_translation.php";
    include "class_mail.php";
    include "mod_site.php";

    $cTrans = new cTranslation;
    $cTrans->SetTranslationFile($SHOP_LANGUAGE_FILE);

    // functions

    // Return array of navigation links
    function get_shop_navigationlinks()
    {
        global $SHOP_MAIN_SITE;
        global $SHOP_BASKET_SITE;
        global $SHOP_ORDER_SITE;
        global $SHOP_TERMS_SITE;
        global $SHOP_IMPRINT_SITE;
        global $SHOP_CONTACT_SITE;
        global $SHOP_HELP_SITE;
        global $SHOW_CONTACT;
        global $SHOP_SHOWHELP;

        $shopLinks = array();
        $shopLinks[] = $SHOP_MAIN_SITE;
        $shopLinks[] = $SHOP_BASKET_SITE;
        $shopLinks[] = $SHOP_ORDER_SITE;
        $shopLinks[] = $SHOP_TERMS_SITE;
        $shopLinks[] = $SHOP_IMPRINT_SITE;
        if ($SHOW_CONTACT == true)
            $shopLinks[] = $SHOP_CONTACT_SITE;
        if ($SHOP_SHOWHELP == true)
            $shopLinks[] = $SHOP_HELP_SITE;

        return $shopLinks;
    }

    // Return array of navigation titles
    function get_shop_navigationtitles()
    {
        global $SHOW_CONTACT;
        global $SHOP_SHOWHELP;
        global $BUTTONTITLE_MAIN;
        global $BUTTONTITLE_BASKET;
        global $BUTTONTITLE_ORDER;
        global $BUTTONTITLE_TERMS;
        global $BUTTONTITLE_IMPRINT;
        global $BUTTONTITLE_CONTACT;
        global $BUTTONTITLE_HELP;
        global $cTrans;

        $shopTitles = array();
        $textMain = $BUTTONTITLE_MAIN;
        if ($textMain == "")
           $textMain = $cTrans->GetTranslation('shop_link_main');
        $shopTitles[] = $textMain;
        $textBasket = $BUTTONTITLE_BASKET;
        if ($textBasket == "")
            $textBasket = $cTrans->GetTranslation('shop_link_basket');
        $shopTitles[] = $textBasket;
        $textOrder = $BUTTONTITLE_ORDER;
        if ($textOrder == "")
            $textOrder = $cTrans->GetTranslation('shop_link_order');
        $shopTitles[] = $textOrder;
        $textTerms = $BUTTONTITLE_TERMS;
        if ($textTerms == "")
            $textTerms = $cTrans->GetTranslation('shop_link_terms');
        $shopTitles[] = $textTerms;
        $textImprint = $BUTTONTITLE_IMPRINT;
        if ($textImprint == "")
            $textImprint = $cTrans->GetTranslation('shop_link_impress');
        $shopTitles[] = $textImprint;
        if ($SHOW_CONTACT == true)
        {
            $textContact = $BUTTONTITLE_CONTACT;
            if ($textContact == "")
                $textContact = $cTrans->GetTranslation('shop_link_contact');
            $shopTitles[] = $textContact;
        }
        if ($SHOP_SHOWHELP == true)
        {
            $textHelp = $BUTTONTITLE_HELP;
            if ($textHelp == "")
                $textHelp = $cTrans->GetTranslation('shop_link_help');
            $shopTitles[] = $textHelp;
        }
        return $shopTitles;
    }
    
    // Get cutomizable footer content
    function get_shop_footer()
    {
        global $FOOTER_CONFIG_FILE;
        $cFile = new cTextFile;
        return $cFile->LoadFromFile($FOOTER_CONFIG_FILE);
    }

    // Build the shop bottom links
    function build_shop_bottom_links($nameLeft, $valueLeft, $nameRight = "", $valueRight = "", $withForm = true)
    {
        $cContent = "";
        $cContent .= echo_sr ('<br>');
        if ($withForm == true)
            $cContent .= echo_sr ('<form method="post" action="">');
        $cContent .= echo_sr ('<table class="bottom_tbl">');
        $cContent .= echo_sr ('<tr>');
        $cContent .= echo_sr ('  <td>');
        $cContent .= echo_sr ('    <input type="submit" class="bottom_btn" id="' . $nameLeft . '_btn" name="' . $nameLeft . '" value="' . $valueLeft . '">');
        if ($nameRight != "")
            $cContent .= echo_sr ('    <input type="submit" class="bottom_btn" id="' . $nameRight . '_btn" name="' . $nameRight . '" value="' . $valueRight . '">');
        $cContent .= echo_sr ('  </td>');
        $cContent .= echo_sr ('</tr>');
        $cContent .= echo_sr ('</table>');
        if ($withForm == true)
            $cContent .= echo_sr ('</form>');
        return $cContent;
    }

    // Build the shop login
    function build_shop_login()
    {
        global $ENABLE_CUSTOMER_LOGIN;
        global $ENABLE_CUSTOMER_REGISTRATION;
        global $FORCE_CUSTOMER_LOGIN;
        global $SHOP_LOGIN_SITE;
        global $SHOP_LOGOUT_SITE;
        global $SHOP_PROFILE_SITE;
        global $SHOP_REGISTER_SITE;
        global $cTrans;

        $cContent = "";
        if ($ENABLE_CUSTOMER_LOGIN == true)
        {
            $cContent .= echo_sr ('<p class="shoplogin_p" style="text-align: right">');
            // Login / Logout
            if (check_login() == false)
            {
                $cContent .= ('<a href="' . $SHOP_LOGIN_SITE . '">' . $cTrans->GetTranslation('shop_link_login') . '</a>');
                if ($ENABLE_CUSTOMER_REGISTRATION == true)
                    // Register user
                    $cContent .= echo_sr ('&nbsp;&nbsp;<a href="' . $SHOP_REGISTER_SITE. '">' . $cTrans->GetTranslation('shop_link_register') . '</a>');
            }
            else
            {
                $cContent .= ('<a href="' . $SHOP_LOGOUT_SITE . '">' . $cTrans->GetTranslation('shop_link_logout') . ' (' . get_user_name() . ')</a>');
                // Edit profile
                $cContent .= echo_sr ('&nbsp;&nbsp;<a href="' . $SHOP_PROFILE_SITE . '">' . $cTrans->GetTranslation('shop_link_editprofile') . '</a>');
            }
            $cContent .= echo_sr ('</p>');
        }
        if ($FORCE_CUSTOMER_LOGIN == true)
        {
            $cContent .= echo_sr ('<p class="shoplogin_p">');
            // Logout
            $cContent .= ('<a href="' . $SHOP_LOGOUT_SITE . '">' . $cTrans->GetTranslation('shop_link_logout') . ' (' . get_user_name() . ')</a>');
            // Edit profile
            $cContent .= echo_sr ('&nbsp;&nbsp;<a href="' . $SHOP_PROFILE_SITE . '">' . $cTrans->GetTranslation('shop_link_editprofile') . '</a>');
            $cContent .= echo_sr ('</p>');
        }
        return $cContent;
    }

    // Build the sidebar
    function build_shop_sidebar($artId = -1)
    {
        global $SHOP_SIDEBAR_RECENT;
        global $SHOP_SIDEBAR_NEWEST;
        global $SHOP_SIDEBAR_CHEAPEST;
        global $SHOP_SIDEBAR_POPULAR;
        global $SHOP_SIDEBAR_MOSTORDERED;
        global $ARTICLE_FOLDER;
        global $SHOP_SIDEBAR_ARTICLE_COUNT;
        global $SHOP_SIDEBAR_WIDTH;
        global $cTrans;

        $cArtSidebar = new cSidebar;
        $cArtSidebar->SetFolder($ARTICLE_FOLDER);
        $cArtSidebar->SetArticleCount($SHOP_SIDEBAR_ARTICLE_COUNT);

        $cContent = "";
        $cContent .= echo_sr ('<!-- begin sidebar -->');
        $cContent .= echo_sr ('<table border="0">');
        $cContent .= echo_sr ('<tr>');
        $cContent .= echo_sr ('<td class="sidebardiv_td" width="' . $SHOP_SIDEBAR_WIDTH . '" align="right">');
        // Sidebar -> recent
        if ($SHOP_SIDEBAR_RECENT == true)
        {
            if ($artId != -1)
                add_sidebar_article($artId, $ARTICLE_FOLDER, $SHOP_SIDEBAR_ARTICLE_COUNT);
            if ($artId == - 1)  // No recent on detail page
            {
                $artArticles = $cArtSidebar->GetRecentArticles();
                $cContent .= build_shop_sidebar_container($cTrans->GetTranslation('shop_sidebar_recent'), $artArticles);
            }
        }
        // Sidebar -> similar
        if ($SHOP_SIDEBAR_RECENT == true && $artId != -1)
        {
            $artArticles = $cArtSidebar->GetSimilarArticles($artId);
            $cContent .= build_shop_sidebar_container($cTrans->GetTranslation('shop_sidebar_similar'), $artArticles);
        }
         // Sidebar -> newest
        if ($SHOP_SIDEBAR_NEWEST == true)
        {
            $artArticles = $cArtSidebar->GetNewestArticles();
            $cContent .= build_shop_sidebar_container($cTrans->GetTranslation('shop_sidebar_newest'), $artArticles);
        }
        // Sidebar -> cheapest
        if ($SHOP_SIDEBAR_CHEAPEST == true)
        {
            $artArticles = $cArtSidebar->GetCheapestArticles();
            $cContent .= build_shop_sidebar_container($cTrans->GetTranslation('shop_sidebar_cheapest'), $artArticles);
        }
        // Sidebar -> popular
        if ($SHOP_SIDEBAR_POPULAR == true)
        {
            $artArticles = $cArtSidebar->GetPopularArticles();
            $cContent .= build_shop_sidebar_container($cTrans->GetTranslation('shop_sidebar_popular'), $artArticles);
        }
        // Sidebar -> most ordered
        if ($SHOP_SIDEBAR_MOSTORDERED == true)
        {
            $artArticles = $cArtSidebar->GetMostOrderedArticles();
            $cContent .= build_shop_sidebar_container($cTrans->GetTranslation('shop_sidebar_mostordered'), $artArticles);
        }
        $cContent .= echo_sr ('</td>');
        $cContent .= echo_sr ('</tr>');
        $cContent .= echo_sr ('</table>');
        $cContent .= echo_sr ('<!-- end sidebar -->');
        return $cContent;
    }

    // Build a sidebar container
    function build_shop_sidebar_container($titleText, $artArray)
    {
        global $SIDEBAR_IMAGE_WIDTH;
        global $SIDEBAR_IMAGE_HEIGHT;
        global $SHOP_SIDEBAR_WIDTH;

        if (count($artArray) == 0)  // Do not display, if no content!
            return "";
            
        $cContent = "";
        $cContent .= echo_sr ('<table class="sidebartop_tbl" style="border: 0px; background-color: #ccccdd;" width="' . $SHOP_SIDEBAR_WIDTH . '">');
        $cContent .= echo_sr ('<tr><td>' . $titleText . '</td></tr>');
        $cContent .= echo_sr ('</table>');
        $cContent .= echo_sr ('<table class="sidebar_tbl" style="border: 1px; border-style: solid; border-color: #ccccdd;" width="' . $SHOP_SIDEBAR_WIDTH . '">');
        $cContent .= echo_sr ('<tr><td>');
        for ($i = 0; $i < count($artArray); $i ++)
        {
            $cContent .= echo_sr ('      <center>');
            $cContent .= build_shop_article_thumb($artArray[$i], false, $SIDEBAR_IMAGE_WIDTH, $SIDEBAR_IMAGE_HEIGHT);
            $cContent .= echo_sr ('      </center>');
        }
        $cContent .= echo_sr ('</td></tr>');
        $cContent .= echo_sr ('</table>&nbsp;');
        return $cContent;
    }

    // Build an article thumbnail
    function build_shop_article_thumb($artId, $showPrice = true, $imgWidth, $imgHeight, $videoHint = "")
    {
        global $SHOP_DETAIL_SITE;
        global $SHOP_CURRENCY;
        global $ARTICLE_FOLDER;
        global $ARTICLE_CUSTOM_FIELD_COUNT;
        global $SHOP_VIDEO_IMAGE;
        global $SHOW_VIDEO_HINT;

        $artArticle = new cArticle;
        $artArticle->SetFolder($ARTICLE_FOLDER);
        $artArticle->SetCustFieldCount($ARTICLE_CUSTOM_FIELD_COUNT);
        $artArticle->LoadArticleFromId($artId);
        $cContent = "";
        $cContent .= ('      <a href="' . $SHOP_DETAIL_SITE . '?art_id=' . $artArticle->GetId() . '">');
        $cContent .= ('<img class="sidebar_img" width="' . $imgWidth . '" height="' . $imgHeight . '" src="' . $artArticle->GetImgThumbUrl() . '" alt="' . $artArticle->GetName() . '">');
        if ($videoHint != "" && $artArticle->GetVideo() != "" && $SHOW_VIDEO_HINT == true)
            $cContent .= ('<img src="' . $SHOP_VIDEO_IMAGE . '" alt="' . $videoHint . '" title="' . $videoHint . '">');
        $cContent .= echo_sr ('</a>');
        $cContent .= echo_sr ('      <br>' . $artArticle->GetName());
        if ($showPrice == true)
            $cContent .= echo_sr ('      <br>(' . $artArticle->GetPrice() . ' ' . $SHOP_CURRENCY . ')');
        return $cContent;
    }

    // Add article to sidebar
    function add_sidebar_article($artId, $artFolder, $artCount)
    {
        $cArtSidebar = new cSidebar;
        $cArtSidebar->SetFolder($artFolder);
        $cArtSidebar->SetArticleCount($artCount);
        $cArtSidebar->AddRecentArticle($artId);
    }

    // Build an article thumbnail
    function build_article_thumb($artId, $showPrice = true, $imgWidth, $imgHeight, $videoHint = "")
    {
        global $SHOP_DETAIL_SITE;
        global $SHOP_CURRENCY;
        global $ARTICLE_FOLDER;
        global $ARTICLE_CUSTOM_FIELD_COUNT;
        global $SHOP_VIDEO_IMAGE;
        global $SHOW_VIDEO_HINT;

        $cContent = "";
        $artArticle = new cArticle;
        $artArticle->SetFolder($ARTICLE_FOLDER);
        $artArticle->SetCustFieldCount($ARTICLE_CUSTOM_FIELD_COUNT);
        $artArticle->LoadArticleFromId($artId);
        $cContent .= ('      <a href="' . $SHOP_DETAIL_SITE . '?art_id=' . $artArticle->GetId() . '">');
        $cContent .= ('<img class="article_img" width="' . $imgWidth . '" height="' . $imgHeight . '" src="' . $artArticle->GetImgThumbUrl() . '" alt="' . $artArticle->GetName() . '">');
        if ($videoHint != "" && $artArticle->GetVideo() != "" && $SHOW_VIDEO_HINT == true)
            $cContent .= ('<img src="' . $SHOP_VIDEO_IMAGE . '" alt="' . $videoHint . '" title="' . $videoHint . '">');
        $cContent .= echo_sr ('</a>');
        $cContent .= echo_sr ('      <br>' . $artArticle->GetName());
        if ($showPrice == true)
            $cContent .= echo_sr ('      <br>(' . $artArticle->GetPrice() . ' ' . $SHOP_CURRENCY . ')');
            
        return $cContent;
    }

    function log_in($userName, $userType)
    {
        global $SHOP_SESS_USER;
        global $SHOP_SESS_TYPE;

        if (!isset($_SESSION))
            session_start();
        $_SESSION[$SHOP_SESS_USER] = $userName;
        $_SESSION[$SHOP_SESS_TYPE] = $userType;
    }

    function log_out()
    {
        global $SHOP_LOGIN_SITE;
        global $SHOP_SESS_USER;
        global $SHOP_SESS_TYPE;

        if (!isset($_SESSION))
            session_start();
        unset($_SESSION[$SHOP_SESS_USER]);
        unset($_SESSION[$SHOP_SESS_TYPE]);
    }

    function get_user_name()
    {
        global $SHOP_SESS_USER;
        return $_SESSION[$SHOP_SESS_USER];
    }

    function check_login()
    {
        global $SHOP_SESS_USER;
        global $SHOP_SESS_TYPE;

        if (!isset($_SESSION))
            session_start();
        if (isset($_SESSION[$SHOP_SESS_USER]) == false || $_SESSION[$SHOP_SESS_USER] < 0 || isset($_SESSION[$SHOP_SESS_TYPE]) == false || $_SESSION[$SHOP_SESS_TYPE] < 0)
            return false;
            
        return true;
    }

    function get_auth()
    {
        global $SHOP_SESS_TYPE;

        if (!isset($_SESSION))
            session_start();
            
        if (isset($_SESSION[$SHOP_SESS_TYPE]) == false || $_SESSION[$SHOP_SESS_TYPE] < 0)
            return -1;
        return $_SESSION[$SHOP_SESS_TYPE];
    }

    function user_is_customer()
    {
        global $USERTYPE_REPORTER;
        return (get_auth() < $USERTYPE_REPORTER);
    }

    function echo_r($strString)
    {
        global $LINE_FEED;
        echo ($strString . $LINE_FEED);
    }

    // Echo string with linefeed
    function echo_sr($sString)
    {
        global $LINE_FEED;
        return $sString . $LINE_FEED;
    }

    // Echo string
    function echo_s($sString)
    {
        return $sString;
    }

    function format_price($priceString)
    {
        return sprintf("%01.2f", $priceString);
    }

    function log_message($messageText)
    {
       global $SHOP_COUNT_LOG;
       global $ADMIN_LOG_ARCHIVE;
       global $MAX_LOG_SIZE;

	   $count = new class_counter;
       $count->set_files("", $SHOP_COUNT_LOG, "", $ADMIN_LOG_ARCHIVE);   // logging only
	   $count->set_max_logsize($MAX_LOG_SIZE);
	   $count->set_count_log(false, true);  // logging only
	   $count->increase("SHOP: " . $messageText);
    }

    function send_mail($receiver, $title, $message, $sender)
    {
        global $MAIL_FOLDER;
        $cEmail = new cMail;

        return $cEmail->SendMailByParams($receiver, $title, $message, $sender, $MAIL_FOLDER);
    }
    
    function get_admin_link()
    {
        $cSysFile = new cSystemFile;
        $adminLink = 'http://' . $_SERVER['HTTP_HOST'];
        $adminLink = $adminLink . $cSysFile->GetPrevFolder($cSysFile->GetPrevFolder($_SERVER['PHP_SELF'])) . 'admin/index.php';
        return $adminLink;
    }